// Google AdMob setup

var admobid = {};
if (/(android)/i.test(navigator.userAgent)) {
  admobid = { // for Android
    banner: 'ca-app-pub-3845646451950436/5145300303', // change this value with your Android AdMob Banner ID
    interstitial: 'ca-app-pub-3845646451950436/6622033502' // change this value with your Android AdMob Interstitial ID
  };
} else if (/(ipod|iphone|ipad)/i.test(navigator.userAgent)) {
  admobid = { // for iOS
    banner: 'ca-app-pub-3845646451950436/8238367500', // change this value with your iOS AdMob Banner ID
    interstitial: 'ca-app-pub-3845646451950436/2191833907' // change this value with your iOS AdMob Interstitial ID
  };
} else {
  // admobid = { // for Windows Phone
  //     banner: 'ca-app-pub-3709095601931870/7754515340',
  //     interstitial: 'ca-app-pub-3709095601931870/9231248541'
  // };
}

// determine device platform
if (( /(ipad|iphone|ipod|android|windows phone)/i.test(navigator.userAgent) )) {
  document.addEventListener('deviceready', initApp, false);
} else {
  initApp();
}

// init AdMob plugin, if error then show alert
function initApp() {
  if (!AdMob) {
    console.log('admob plugin not ready');
    return;
  }


  // customize banner appearance
  AdMob.createBanner({
    adId: admobid.banner,
    isTesting: false,
    overlap: false,
    offsetTopBar: false,
    autoShow: false,
    position: 8,
    bgColor: 'black'
  });

  // customize interstitial
  AdMob.prepareInterstitial({
    adId: admobid.interstitial,
    autoShow: false
  });
}
