angular.module('starter').controller('QuestionCtrl', function ($scope, $rootScope, $database, $localstorage, $stateParams, $cordovaSocialSharing, $ionicHistory, $cordovaSQLite, $state, $timeout, $ionicModal, $ionicLoading, $ionicPopup, $ionicScrollDelegate, $http) {

    $ionicHistory.clearHistory();
    $ionicHistory.clearCache();

    // Define variables
    var dataArray = [];
    var score = 0;
    var TEST_Q;
    var testScore = 0;
    var diff, minutes, seconds, duration;
    var timeOver = false;
    var alertPopup, errorPopup;
    var click = false;
    var timed = false;
    var cat;
    var res;
    var itm = 0;
    var endedTest = false;
    var dbq = window.db;
    var title = $stateParams.title;
    var examId = $stateParams.examId;
    var recordProgress, nextExam, minScore;
    var showAd;
    var mytimeout = null;
    var user = $localstorage.get('userID', 'QUIZ');
    var Paid = window.Paid;
    var valid = false;
    var testTime, spentTime;
    // added in 1.4
    var highlight;
    var explanation;

    // Define scope variables for GUI
    $scope.count = 0;
    $scope.viewTitle = title;
    $scope.timerTimeout = null;
    $scope.timed = false;
    $scope.qty = 0;


    $scope.action = "Skip";
    $scope.selectedRow = null;

    // ************************************
    // question.js functions declarations
    // ************************************

    //timer function to animate myTimer countdown
    onTimerTimeout = function () {
      var timerTest = document.getElementById('myTimer');
      diff = duration--;
      spentTime = testTime - diff;
      //console.log('time used: ' + spentTime);
      if (diff === 0) {
        $scope.$broadcast('timer-stopped', 0);
        $timeout.cancel($scope.timerTimeout);
        return;
      }

      // format timer value
      minutes = (diff / 60) | 0;
      seconds = (diff % 60) | 0;
      minutes = minutes < 10 ? "0" + minutes : minutes;
      seconds = seconds < 10 ? "0" + seconds : seconds;
      $scope.time = minutes + ":" + seconds;

      if (diff <= 10) { //if timeleft < 10s we animate timer and change its color text

        move(timerTest)
          .ease('snap')
          .set('opacity', '1')
          .set('color', 'red')
          .scale(1.3)
          .duration('0s')
          .end();

        move(timerTest)
          .ease('out')
          .scale(1)
          .set('opacity', 0)
          .duration('1s')
          .end();
      }

      if (!timeOver) {
        $scope.timerTimeout = $timeout(onTimerTimeout, 1000);
      }
    };

    preload = function () {
      //preload test information
      return $database.preloadTest(examId).then(function (res) {
          console.log(JSON.stringify(res));
          if (res.rows.length > 0) {
            TEST_Q = res.rows.item(0).Qty;
            $scope.qty = TEST_Q;
            //TEST_Q=10; //just for tersting/debugging on limited questions

            duration = res.rows.item(0).Duration;
            recordProgress = res.rows.item(0).Progress;
            nextExam = res.rows.item(0).NextExam;
            minScore = res.rows.item(0).MinScore;
            cat = res.rows.item(0).CatId;
            if (duration > 0) {
              timed = true;
              //duration=15; //override duration for testing purpose;
              $scope.timed = true;
              $scope.$root.show = true;
            } else {
              timed = false;
              $scope.timed = false;
              $scope.$root.show = false;
            }
            return true;
          } else {
            // if res = 0, means test not available
            valid = false;
            console.log("Test not available");

            // create an alert to notify the user
            errorPopup = $ionicPopup.alert({
              title: "Test not available yet",
              template: '',
              okText: 'Close'
            });

            errorPopup.then(function (res) {
              $timeout(function () {
                exit();
              }, 250);
            });
            return false;
          }

        }, function (e) {
          console.log("ERROR: " + e.message);
          return false;
        }
      );
    };

    loadQ = function () {
      //Load random questions for selected test
      if (window.cordova) {
        // If we run App on device, we can use RANDOM () function from SQLite
        $database.getQuestionsByCat(cat, TEST_Q).then(function (res) {
          dataArray = res;
        });
      } else {
        // We handle the missing of RANDOM() function in WebSQL when executing APP in a Browser (Chrome or Safari)
        $database.getIds(cat).then(function (res) {
          //console.log(res);
          dataArray = $database.getQuestionsById(TEST_Q, res);
          //console.log(dataArray);
        });
      }

      // temporary message when loading questions
      $ionicLoading.show({
        template: '<span class="icon spin ion-loading-d"></span> Loading questions...'
      });

      // track this view
      if (window.analytics) {
        window.analytics.setUserId(user);
        window.analytics.trackView(title);
      }
    };

    // main loop to present questions and options
    questionShow = function () {

      // updates timer count
      if (timed && $scope.timerTimeout === null) {
        testTime = duration;
        $scope.timerTimeout = $timeout(onTimerTimeout(), 1000);
      }
      if (!timeOver) {

        // check if last question was reached
        if ($scope.count < TEST_Q) {
          $scope.question = '';

          var qstatus = null;
          $scope.count++;
          $scope.question = dataArray[itm].Question;

          $scope.answer = dataArray[itm].Answer;
          $scope.status = dataArray[itm].Status;
          $scope.id = dataArray[itm].Id;
          //console.log(dataArray[itm].Explanation);
          $scope.optionList = [];

          var data = dataArray[itm];
          var valueToPush;

          for (var k in data) { // fill $scope.optionList only with available answers
            if (data.hasOwnProperty(k) && data[k] !== "" && data[k] !== null && k in {
                'A': '',
                'B': '',
                'C': '',
                'D': '',
                'E': ''
              }) {
              //console.log(data[k], k);
              valueToPush = {};
              valueToPush.text = k + ') ' + data[k];
              valueToPush.value = k;
              valueToPush.flag = null;
              //console.log(valueToPush.text, valueToPush.value);
              $scope.optionList.push(valueToPush);

            }
          }
          // we sort the options as they are retrieved unordered from for in loop function
          $scope.optionList.sort(function (a, b) {
            if (a.value > b.value) {
              return 1;
            }
            if (a.value < b.value) {
              return -1;
            }
            // a must be equal to b
            return 0;
          });

          data = null;

          // force scrolable view to scroll to the top, so Question text is shown correct.
          $ionicScrollDelegate.scrollTop();

        } else {
          showAlert(', you\'ve reached the last question', testScore);
          $scope.action = null;
        }
      } else {
        showAlert(', Time Over !', testScore);
        $scope.action = null;
      }
    };

    exit = function () {
      //clear navigation history
      $ionicHistory.nextViewOptions({
        historyRoot: true
      });

      //cancel timer if still active
      if (timed) {
        $timeout.cancel($scope.timerTimeout);
        $scope.timerTimeout = null;
        timed = false;
      }

      //flag endtest
      endedTest = true;

      //remove AdMob banner
      if (window.AdMob) {
        window.AdMob.removeBanner();
      }

      //reset questions used for executed test, so they will be available for next one
      $database.resetStatusOnQuestions().then(function (res) {
        $state.go('app.home');
      });
    };

    showAlert = function (message, testScore) {
      if ($scope.timerTimeout) {
        $timeout.cancel($scope.timerTimeout);
        $scope.timerTimeout = null;
        timed = false;
      }
      endedTest = true;
      if (!alertPopup) {

        testScore = Math.floor((score / $scope.count) * 100);
        //update Progress table with user's score

        //// We only record progress in Paid version and if exam has Progress="Y" (modified on March 3rd,2016)
        if (Paid && recordProgress == "Y") {
          if (!spentTime) {
            spentTime = 0;
          }
          //this call has been updated on @2016-06-15 to recode progress in the new database
          $database.updateProgress(user, examId, title, testScore, spentTime);
        }
        // Check if a following exam shall be unlocked
        if (nextExam !== null && testScore >= minScore) {
          $database.unlockExamById(nextExam);
          $rootScope.$broadcast("menu-updated", true);
        }

        // Prepare Interestitial ads, so it's displayed before acceding to the final test score
        if (window.AdMob) {
          window.AdMob.removeBanner();
          if (showAd) {
            window.AdMob.prepareInterstitial({
              adId: window.admobid.interstitial,
              autoShow: true
            });
          }
        }

        // Shows test score to the user
        alertPopup = $ionicPopup.alert({
          title: user + message,
          template: 'Your score: ' + testScore + '%',
          okText: Paid ? 'View test results' : 'Close'
        });

        // track event
        if (window.analytics) {
          var tracking_ID = device.platform == "Android" ? "UA-63761768-5" : "UA-63761768-4";
          window.analytics.startTrackerWithId(tracking_ID);
          window.analytics.setUserId(user);
          window.analytics.trackEvent('alertPopup', title, 'Scored: ', testScore + "%");
        }

        // reset test score
        score = 0;

        // delay 500ms to display Questions Review (if Full version) or Exit (Free version)
        alertPopup.then(function (res) {
          $timeout(function () {
            $scope.count = 0;
            // if (Paid) {
            $scope.testScore = testScore;
            $scope.timerTimeout = null;
            showResult();
            // } else {
            // exit();
            //}
          }, 500);
        });
      }
    };

    // *******************************
    // All $scope actions from here
    // *******************************

    // watch timer count
    $scope.$on('timer-stopped', function (event, rem) {
      if (rem === 0) {
        endedTest = true;
        timeOver = true;
        showAlert(', Time Over !', testScore);
      }
    });

    // Handle the user's response when selecting an answer
    $scope.setClickedRow = function (item, index) {
      if (!click && !endedTest) {
        click = true;
        if (item.value == $scope.answer) {
          // if question was answered correct, then we update question as answered
          $scope.optionList[index].flag = true;
          dataArray[itm].Status = item.value;
          $database.setQuestionAsCorrect($scope.id);
          score++;
        } else {
          // otherwise we update question as incorrect
          $scope.optionList[index].flag = false;
          dataArray[itm].Status = item.value;
          $database.setQuestionAsIncorrect($scope.id);
          //highlight the correct answer
          if (highlight) {
            $scope.optionList[$scope.answer.charCodeAt(0) - 65].flag = true;
          }
        }
        // shows next question of the test
        if (!explanation) {
          $timeout(function () {
            click = false;
            itm++;
            questionShow();
          }, 1000);
        } else {
          $scope.explanation = true;
        }

      }
    };

    // Allow user to quit from current test
    $scope.quit = function () {
      if (!alertPopup) {
        var confirmPopup = $ionicPopup.confirm({
          title: 'Quitting quiz',
          template: 'Are you sure you want to abandon the quiz?'
        });
        confirmPopup.then(function (res) {
          if (res) {
            exit();
          } else {
            confirmPopup.close();
          }
        });
      }
    };

    // Handle NEXT or SKIP actions depending on test status.
    $scope.doAction = function (doaction) {

      // track this event
      if (window.analytics) {
        window.analytics.setUserId(user);
        window.analytics.trackEvent('button', 'Skip question', 'Current Count: ', $scope.count);
      }

      // display temporary message when skipping a question
      $ionicLoading.show({
        template: '<span class="icon spin ion-loading-d"></span> Skipping question...'
      });

      $timeout(function () {
        $ionicLoading.hide();
        itm++;
        questionShow();
      }, 500);
    };

    // Create the questions review modal view
    $ionicModal.fromTemplateUrl('templates/result.html', {
      scope: $scope
    }).then(function (modal) {
      $scope.modal = modal;
    });

    // Called in the questions review modal view to close it
    $scope.closeResult = function () {
      $database.resetStatusOnQuestions().then(function (res) {
        $scope.modal.hide();
        $ionicHistory.nextViewOptions({
          historyRoot: true
        });
        $state.go('app.home');
      });
    };

    // Allow user to share his/her test result
    $scope.share = function () {
      window.plugins.socialsharing.available(function (isAvailable) {
        // the boolean is only false on iOS < 6
        if (isAvailable) {
          //console.log('Social Activated');
          window.plugins.socialsharing.share('I\'ve scored: ' + $scope.testScore + ' % in ' + title + ', by practicing a quiz with HP Trivia App for iOS & Android', 'Improving my Harry Potter skills with HP Trivia App', null, 'http://devrevolution.com');
        }
      });
    };

    // Handle foot-bar-Next button call
    $scope.nextq = function () {
      // display temporary message when skipping a question
      $ionicLoading.show({
        template: '<span class="icon spin ion-loading-d"></span> Getting next question...'
      });

      $timeout(function () {
        $ionicLoading.hide();
        itm++;
        click = false;
        $scope.explanation = false;
        questionShow();
      }, 1000);
    };

    // Handle foot-bar-Explanation button call
    $scope.expl = function () {
      if (Paid) {
        alertPopupExpl = $ionicPopup.alert({
          title: 'Explanation',
          template: dataArray[itm].Explanation,
          okText: 'Got it'
        });
      } else {
        alertPopupExpl = $ionicPopup.confirm({
          title: 'Explanation',
          template: 'Only available in Full Version. Do You want to buy it?',
          okText: 'Buy it'
        });
      }

      alertPopupExpl.then(function (res) {
        console.log(res);
        if (Paid && res) {
          $timeout(function () {
            itm++;
            click = false;
            $scope.explanation = false;
            questionShow();
          }, 1000);
        } else if (!Paid && res) {
          $database.resetStatusOnQuestions().then(function (result) {
            $ionicHistory.nextViewOptions({
              historyRoot: true
            });
            $state.go('app.store');
          });
        }
      });
    };

    // Open the questions review modal view
    showResult = function () {
      $scope.data = [];
      $scope.modal.show();

      for (j = 0; j < dataArray.length; j++) {
        $scope.data.push(dataArray[j]);
        $scope.data[j].TextA = dataArray[j][(dataArray[j].Answer)];
        $scope.data[j].TextB = dataArray[j][(dataArray[j].Status)];
        if ($scope.data[j].TextA == $scope.data[j].TextB) {
          $scope.data[j].flagA = true;
        } else {
          $scope.data[j].flagA = false;
        }
      }
    };

    // ************************************
    // question.js Entry point of execution
    // ************************************

    // Read config parameters
    readParams = function () {
      // highlight of correct answer feature
      $database.getPropertyValue('highlight').then(function (resh) {
        if (resh == 'false') {
          highlight = false;
        } else {
          highlight = true;
        }
      }, function (error) {
        return (error);
      });

      // Question explanation in free version feature
      $database.getPropertyValue('explanation').then(function (rese) {
        if (rese == 'false') {
          explanation = false;
        } else {
          explanation = true;
        }
      }, function (error) {
        return (error);
      });
    };

    checkVersion = function () {
      // Unlock additional questions in database when Full version is acquired.
      if (Paid) {
        showAd = false;
        $database.unlockAllQuestions();

      } else {
        // When in free version, ensure that extra questions are not enable for test
        // when calling the below function with a parameter, it produces a lock on all questions IDs>x
        // $database.lockQuestions(x); // uncomment this line and replace the x value by your needs.
        $database.lockQuestions(8);
      }
    };

    setAdMob = function () {
      // Show/Hide AdMob feature
      $database.getPropertyValue('admob').then(function (resa) {
        if (resa == 'false' || Paid) {
          showAd = false;
        } else {
          showAd = true;
          if (window.AdMob && showAd) {
            window.AdMob.showBanner(8);
          }
        }
      }, function (error) {
        return (error);
      });

    };

    loadExam = function () {
      preload().then(function (res) {
        if (res) {
          loadQ();
          $timeout(function () {
            $ionicLoading.hide();
            questionShow();
          }, 2000);
        }
      });
    };


    $scope.displayMessage = function (title, message) {
      var alertPopup = $ionicPopup.alert({
        title: title,
        template: message
      });

      alertPopup.then(function (res) {
        console.log('Report alert succesfully displayed');
      });

    };

    $scope.reportQuestion = function (qid) {

      $http.get("http://devrevolution.com/report.php", {
        params: {
          "platform": "ios",
          "appid": "com.devrevolution.hptrivia",
          "qid": qid,
          "dbversion": $rootScope.db_version
        }
      })
        .success(function (data) {
          $scope.displayMessage("Thank you for your report!", data.message);
          console.log("Report sent succesfully " + qid);
        })
        .error(function (data) {
          $scope.displayMessage("Error", "The server is on vacation! Please try again later.");
          console.log("Error! Try again later " + qid);
        });
    };


    readParams();
    //checkVersion();
    setAdMob();
    loadExam();


    // ************************************
    // question.js Exit point
    // ************************************

    // Stop any timer when leaving the view
    $scope.$on('$ionicView.leave', function () {
      if ($scope.timerTimeout) {
        $timeout.cancel($scope.timerTimeout);
        $scope.timerTimeout = null;
        timed = false;
      }
    });
  }
);
